package de.hdm_stuttgart.mi.sda2;

import javax.ws.rs.client.ClientBuilder;
import javax.ws.rs.client.Client;
import javax.ws.rs.client.Entity;
import javax.ws.rs.core.MediaType;
import javax.ws.rs.core.Response;

import org.jboss.resteasy.client.ClientResponse;

import com.restfully.shop.domain.Customer;

public class MyClient {
   public static void main(String[] args) throws Exception {


      Client client = ClientBuilder.newClient();
      try {
         System.out.println("*** Create a new Customer ***");
         Customer goik = new Customer();
         goik.setFirstName("Martin");
         goik.setLastName("Goik");
         goik.setStreet("Nobelstr. 2");
         goik.setCity("Stuttgart");
         goik.setZip("70589");
         goik.setCountry("Germany");
         
         Response response = client.target(
               "http://localhost:8080/services/customers")
               .request().post(Entity.entity(goik, MediaType.APPLICATION_XML_TYPE));

         if (response.getStatus() != 201) {
            throw new RuntimeException("Failed to create entity");
         }
         
         final String location = response.getLocation().toString();
         System.out.println("Location: " + location);
         response.close();
         
         System.out.println("*** GET Created Customer **");
         String customer = client.target(location).request().get(String.class);
         System.out.println(customer);
         
         // Update record
         goik.setLastName("Wurm");
         
         System.out.println("Client side: update first name =" + goik.getFirstName());
         
         response = client.target(location)
               .request()
               .put(Entity.entity(goik, MediaType.APPLICATION_XML_TYPE));
         
         if (response.getStatus() != 204) 
            throw new RuntimeException("Failed to update");
         response.close();
         System.out.println("**** After Update ***");
         customer = client.target(location).request().get(String.class);
         System.out.println(customer);
         
         //Get all Customers
         String customerList = client.target("http://localhost:8080/services/customers").request().get(String.class);
         System.out.println("Customers:\n" + customerList);
         
      } finally {
         client.close();
      }

   }
}
